unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SoftekBarCode;

const UM_RUNTEST=WM_USER+1;

type
  TForm1 = class(TForm)
    meLog: TMemo;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
  private
    procedure UMRunTest(var Msg:TMessage); message UM_RUNTEST;
  public
    procedure RunTest;
    procedure Log(s:string);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Log(s:string);
begin
  meLog.Lines.Add(s);
end;

procedure TForm1.UMRunTest(var Msg:TMessage);
begin
  RunTest;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PostMessage(Self.Handle,UM_RUNTEST,0,0);
end;

procedure TForm1.RunTest;
var NumCodes,PageNo,i:integer;
    pTopLeftX,pTopLeftY,pBotRightX,pBotRightY:integer;
    Start,Stop:DWord;
begin
  if not OpenDialog1.Execute then exit;

  stSetMultipleRead(True);

  meLog.Clear;
  Log('Current Settings:');
  Log(Format('  stGetBitmapResolution()=%d',[stGetBitmapResolution()]));
  Log(Format('  stGetDebugTraceFile()=''%s''',[stGetDebugTraceFile()]));
  Log(Format('  stGetLineJump()=%d',[stGetLineJump()]));
  Log(Format('  stGetLowerRatio()=%f',[stGetLowerRatio()]));
  Log(Format('  stGetMinOccurrence()=%d',[stGetMinOccurrence()]));
  Log(Format('  stGetMultipleRead()=%s',[BoolToStr(stGetMultipleRead(),True)]));
  Log(Format('  stGetNoiseReduction()=%d',[stGetNoiseReduction()]));
  Log(Format('  stGetPageNo()=%d',[stGetPageNo()]));
  Log(Format('  stGetPrefOccurrence()=%d',[stGetPrefOccurrence()]));
  Log(Format('  stGetQuietZoneSize()=%d',[stGetQuietZoneSize()]));
  Log(Format('  stGetRotation()=%d',[stGetRotation()]));
  Log(Format('  stGetUpperRatio()=%f',[stGetUpperRatio()]));
  Log(Format('  stGetReadCode39()=%s',[BoolToStr(stGetReadCode39(),True)]));
  Log(Format('  stGetReadEAN13()=%s',[BoolToStr(stGetReadEAN13(),True)]));
  Log(Format('  stGetReadEAN8()=%s',[BoolToStr(stGetReadEAN8(),True)]));
  Log(Format('  stGetReadUPCA()=%s',[BoolToStr(stGetReadUPCA(),True)]));
  Log(Format('  stGetReadUPCE()=%s',[BoolToStr(stGetReadUPCE(),True)]));
  Log(Format('  stGetReadPatchCodes()=%s',[BoolToStr(stGetReadPatchCodes(),True)]));
  Log(Format('  stGetShowCheckDigit()=%s',[BoolToStr(stGetShowCheckDigit(),True)]));
  Log(Format('  stGetReadCode128()=%s',[BoolToStr(stGetReadCode128(),True)]));
  Log(Format('  stGetCode39NeedStartStop()=%s',[BoolToStr(stGetCode39NeedStartStop(),True)]));
  Log(Format('  stGetReadCode25()=%s',[BoolToStr(stGetReadCode25(),True)]));
  Log(Format('  stGetColorThreshold()=%d',[stGetColorThreshold()]));

  Start:=GetTickCount;
  NumCodes:=stScanBarCode(PChar(OpenDialog1.FileName));
  Stop:=GetTickCount;
  Log(Format('  stScanBarCode(''%s'')=%d',[OpenDialog1.FileName,NumCodes]));
  Log(Format('  Scan time %dms',[Stop-Start]));
  if NumCodes<0 then
    begin
      Log('  Error: '+stGetErrorString(NumCodes));
      exit;
    end;

  Log(Format('  stScanBarCode() found %d Barcodes',[NumCodes]));
  for i:=1 to NumCodes do
    begin
      Log(Format('    %d: stGetBarString(%d)=''%s''',[i,i,stGetBarString(i)]));
      Log(Format('    %d: stGetBarStringType(%d)=%s',[i,i,stGetBarStringType(i)]));
      PageNo:=stGetBarStringPos(i,pTopLeftX,pTopLeftY,pBotRightX,pBotRightY);
      Log(Format('    %d: stGetBarStringPos(%d)=(%d,%d,%d,%d) on Page %d',[i,i,pTopLeftX,pTopLeftY,pBotRightX,pBotRightY,PageNo]));
    end;

end;

initialization
  InitLibrary;
end.
